DECLARE SUB TmrSpeed (Start&)
DECLARE SUB RTC2Timer ()
'-- tmrspeed.bas ----------------------------------------------- >>fst'01<< -
' - Demo, wie der Systemtimer beschleunigt wird
' - Anweisungen, wie SLEEP und ON TIMER koennen anschliessend
'   kleinere Intervalle als 1 Sekunde aufloesen
' - ausserdem wird demonstriert, wie die vorgeeilte Zeit mittels der
'   CMOS Echtzeituhr (Real-Time-Clock "RTC") wieder korrigiert werden kann.
' - PUBLIC DOMAIN
'-- V 20010923 ------------------------------ http://home.arcor.de/steini63 -

CLS
PRINT
PRINT "Beschleunigen & korrigieren des Systemtimers.                        >>fst'01<<"
PRINT "FUNKTIONIERT NUR UNTER PUREM DOS"

 LOCATE 7
 PRINT "Normale Timergeschwindigkeit:"

DO
 LOCATE 8
 PRINT TIME$, "Taste ..."
LOOP WHILE INKEY$ = ""

PRINT
PRINT "Timer um den Faktor 10 beschleunigt:"

Start& = 65535 / 10         'neuen Startwert fuer den PIC bestimmen
CALL TmrSpeed(Start&)       'PIC mit neuem Startwert programmieren

DO
 LOCATE 11
 PRINT TIME$, "Taste ..."
LOOP WHILE INKEY$ = ""

PRINT
PRINT "Timergeschwindigkeit zurueckgesetzt; Uhrzeit mit RTC korrigiert:"

CALL TmrSpeed(65535)     'NICHT VERGESSEN: PIC Startwert auf Standard setzen
CALL RTC2Timer             'Uhrzeit/Datum mittels RTC korrigieren

DO
 LOCATE 14
 PRINT TIME$, DATE$, "Taste ..."
LOOP WHILE INKEY$ = ""

END

SUB RTC2Timer
'Aktualisiert die Systemzeit anhand der CMOS-Echtzeituhr (RTC)

'Zeit der RTC in einem String speichern (Format identisch zu TIME$)
DO
 FOR SB% = 4 TO 0 STEP -2          'SteuerByte 4=Stunde, 2=Minute, 0=Sekunde
  DO: OUT &H70, 10                 'Statusregister A abfragen, wenn Bit 7
  LOOP WHILE INP(&H71) > 127       ' gesetzt, wird gerade aktualisiert
  OUT &H70, SB%                    'SteuerByte ins CMOS-Steuerregister
  in% = INP(&H71)                  'Wert lesen
  in$ = HEX$(in%)                  'BCD-Format wandeln; dezimal->hex->String
  IF LEN(in$) = 1 THEN in$ = "0" + in$   'fuehrende Null ergaenzen
  Zeit$ = Zeit$ + in$              'String zusammenbauen
  IF SB% THEN Zeit$ = Zeit$ + ":"  'Trennzeichen ergaenzen
 NEXT
LOOP WHILE Zeit$ = "23:59:59"      'letzte Sekunde vor Tageswechsel warten,
                                   'damit Zeit und Datum zusammenpassen

'Datum der RTC in einem String speichern (Format identisch zu DATE$):
 FOR i% = 1 TO 4
  IF i% = 1 THEN SB% = 8            'SteuerByte  8=Monat
  IF i% = 2 THEN SB% = 7            'SteuerByte  7=Tag
  IF i% = 3 THEN SB% = 50           'SteuerByte 50=Jahrhundert
  IF i% = 4 THEN SB% = 9            'SteuerByte  9=Jahrzehnt
  DO: OUT &H70, 10                  'Statusregister A abfragen, wenn Bit 7
  LOOP WHILE INP(&H71) > 127        ' gesetzt, wird gerade aktualisiert
  OUT &H70, SB%                     'SteuerByte ins CMOS-Steuerregister
  in% = INP(&H71)                   'Wert lesen
  in$ = HEX$(in%)                   'BCD-Format wandeln; dezimal->hex->String
  IF LEN(in$) = 1 THEN in$ = "0" + in$   'fuehrende Null ergaenzen
  Dat$ = Dat$ + in$                 'String zusammenbauen
  IF i% < 3 THEN Dat$ = Dat$ + "-"  'Trennzeichen ergaenzen
 NEXT

'Plausibilaetskontrolle:
Jahr% = VAL(RIGHT$(Dat$, 4))
Monat% = VAL(LEFT$(Dat$, 2))
Std% = VAL(LEFT$(Zeit$, 2))
IF Jahr% < 1900 OR Jahr% > 2999 THEN Fehler% = -1
IF Monat% < 1 OR Monat% > 12 THEN Fehler% = -1
IF Std% < 0 OR Std% > 24 THEN Fehler% = -1
IF Fehler% THEN BEEP: PRINT " *** Werte der Echtzeituhr ungueltig *** ": EXIT SUB

'Uhrzeit nach Echtzeituhr stellen:
DATE$ = Dat$
TIME$ = Zeit$

END SUB

SUB TmrSpeed (Start&)
'setzt einen neuen Startwert fuer den PIT 8253/8254
'Standard ist 65535, jede Verringerung um 1 beschleunigt
'den Systemtimer um 0,838 Mikrosekunden.

Lo% = Start& MOD 256  'LowByte von Start& ermitteln
Hi% = Start& \ 256    'HighByte von Start& ermitteln

OUT (&H43), 52        '52 = &b00110100 8253/Timer0 auf Modus 2 setzen
OUT (&H40), Lo%       'Startwert LowByte setzen
OUT (&H40), Hi%       'Startwert HighByte setzen
END SUB

